<!DOCTYPE HTML>
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (14) on Fri May 29 23:30:56 CEST 2020 -->
<title>BCrypt</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta name="dc.created" content="2020-05-29">
<meta name="description" content="declaration: package: Heroes.User, class: BCrypt">
<meta name="generator" content="javadoc/ClassWriterImpl">
<link rel="stylesheet" type="text/css" href="../../stylesheet.css" title="Style">
<link rel="stylesheet" type="text/css" href="../../script-dir/jquery-ui.css" title="Style">
<script type="text/javascript" src="../../script.js"></script>
<script type="text/javascript" src="../../script-dir/jszip/dist/jszip.min.js"></script>
<script type="text/javascript" src="../../script-dir/jszip-utils/dist/jszip-utils.min.js"></script>
<!--[if IE]>
<script type="text/javascript" src="../../script-dir/jszip-utils/dist/jszip-utils-ie.min.js"></script>
<![endif]-->
<script type="text/javascript" src="../../script-dir/jquery-3.4.1.js"></script>
<script type="text/javascript" src="../../script-dir/jquery-ui.js"></script>
</head>
<body class="class-declaration">
<script type="text/javascript">var data = {"i0":9,"i1":10,"i2":9,"i3":9,"i4":9,"i5":9};
var tabs = {65535:["t0","All Methods"],1:["t1","Static Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
var pathtoroot = "../../";
loadScripts(document, 'script');</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<div class="flexBox">
<header role="banner" class="flexHeader">
<nav role="navigation">
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a id="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a id="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../index.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/BCrypt.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../index-files/index-1.html">Index</a></li>
<li><a href="../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<div class="navListSearch"><label for="search">SEARCH:</label>
<input type="text" id="search" value="search" disabled="disabled">
<input type="reset" id="reset" value="reset" disabled="disabled">
</div>
</div>
<!-- ========= END OF TOP NAVBAR ========= -->
<div class="skipNav"><a id="skip.navbar.top">
<!--   -->
</a></div>
</nav>
</header>
<div class="flexContent">
<main role="main">
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle"><span class="packageLabelInType">Package</span>&nbsp;<a href="package-summary.html">Heroes.User</a></div>
<h1 title="Class BCrypt" class="title">Class BCrypt</h1>
</div>
<div class="contentContainer">
<div class="inheritance" title="Inheritance Tree">java.lang.Object
<div class="inheritance">Heroes.User.BCrypt</div>
</div>
<section class="description">
<hr>
<pre>public class <span class="typeNameLabel">BCrypt</span>
extends java.lang.Object</pre>
<div class="block">BCrypt implements OpenBSD-style Blowfish password hashing using
 the scheme described in "A Future-Adaptable Password Scheme" by
 Niels Provos and David Mazieres.
 <p>
 This password hashing system tries to thwart off-line password
 cracking using a computationally-intensive hashing algorithm,
 based on Bruce Schneier's Blowfish cipher. The work factor of
 the algorithm is parameterised, so it can be increased as
 computers get faster.
 <p>
 Usage is really simple. To hash a password for the first time,
 call the hashpw method with a random salt, like this:
 <p>
 <code>
 String pw_hash = BCrypt.hashpw(plain_password, BCrypt.gensalt()); <br/>
 </code>
 <p>
 To check whether a plaintext password matches one that has been
 hashed previously, use the checkpw method:
 <p>
 <code>
 if (BCrypt.checkpw(candidate_password, stored_hash))<br/>
 &nbsp;&nbsp;&nbsp;&nbsp;System.out.println("It matches");<br/>
 else<br/>
 &nbsp;&nbsp;&nbsp;&nbsp;System.out.println("It does not match");<br/>
 </code>
 <p>
 The gensalt() method takes an optional parameter (log_rounds)
 that determines the computational complexity of the hashing:
 <p>
 <code>
 String strong_salt = BCrypt.gensalt(10)<br/>
 String stronger_salt = BCrypt.gensalt(12)<br/>
 </code>
 <p>
 The amount of work increases exponentially (2**log_rounds), so 
 each increment is twice as much work. The default log_rounds is
 10, and the valid range is 4 to 30.</div>
<dl>
<dt><span class="simpleTagLabel">Version:</span></dt>
<dd>0.2</dd>
<dt><span class="simpleTagLabel">Author:</span></dt>
<dd>Damien Miller</dd>
</dl>
</section>
<section class="summary">
<ul class="blockList">
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<li class="blockList">
<section class="constructorSummary"><a id="constructor.summary">
<!--   -->
</a>
<h2>Constructor Summary</h2>
<div class="memberSummary">
<table>
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<thead>
<tr>
<th class="colFirst" scope="col">Constructor</th>
<th class="colLast" scope="col">Description</th>
</tr>
</thead>
<tbody>
<tr class="altColor">
<th class="colConstructorName" scope="row"><code><span class="memberNameLink"><a href="#%3Cinit%3E()">BCrypt</a></span>()</code></th>
<td class="colLast">&nbsp;</td>
</tr>
</tbody>
</table>
</div>
</section>
</li>
<!-- ========== METHOD SUMMARY =========== -->
<li class="blockList">
<section class="methodSummary"><a id="method.summary">
<!--   -->
</a>
<h2>Method Summary</h2>
<div class="memberSummary">
<div role="tablist" aria-orientation="horizontal"><button role="tab" aria-selected="true" aria-controls="memberSummary_tabpanel" tabindex="0" onkeydown="switchTab(event)" id="t0" class="activeTableTab">All Methods</button><button role="tab" aria-selected="false" aria-controls="memberSummary_tabpanel" tabindex="-1" onkeydown="switchTab(event)" id="t1" class="tableTab" onclick="show(1);">Static Methods</button><button role="tab" aria-selected="false" aria-controls="memberSummary_tabpanel" tabindex="-1" onkeydown="switchTab(event)" id="t2" class="tableTab" onclick="show(2);">Instance Methods</button><button role="tab" aria-selected="false" aria-controls="memberSummary_tabpanel" tabindex="-1" onkeydown="switchTab(event)" id="t4" class="tableTab" onclick="show(8);">Concrete Methods</button></div>
<div id="memberSummary_tabpanel" role="tabpanel">
<table aria-labelledby="t0">
<thead>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colSecond" scope="col">Method</th>
<th class="colLast" scope="col">Description</th>
</tr>
</thead>
<tbody>
<tr class="altColor" id="i0">
<td class="colFirst"><code>static boolean</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#checkpw(java.lang.String,java.lang.String)">checkpw</a></span>&#8203;(java.lang.String&nbsp;plaintext,
java.lang.String&nbsp;hashed)</code></th>
<td class="colLast">
<div class="block">Check that a plaintext password matches a previously hashed
 one</div>
</td>
</tr>
<tr class="rowColor" id="i1">
<td class="colFirst"><code>byte[]</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#crypt_raw(byte%5B%5D,byte%5B%5D,int,int%5B%5D)">crypt_raw</a></span>&#8203;(byte[]&nbsp;password,
byte[]&nbsp;salt,
int&nbsp;log_rounds,
int[]&nbsp;cdata)</code></th>
<td class="colLast">
<div class="block">Perform the central password hashing step in the
 bcrypt scheme</div>
</td>
</tr>
<tr class="altColor" id="i2">
<td class="colFirst"><code>static java.lang.String</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#gensalt()">gensalt</a></span>()</code></th>
<td class="colLast">
<div class="block">Generate a salt for use with the BCrypt.hashpw() method,
 selecting a reasonable default for the number of hashing
 rounds to apply</div>
</td>
</tr>
<tr class="rowColor" id="i3">
<td class="colFirst"><code>static java.lang.String</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#gensalt(int)">gensalt</a></span>&#8203;(int&nbsp;log_rounds)</code></th>
<td class="colLast">
<div class="block">Generate a salt for use with the BCrypt.hashpw() method</div>
</td>
</tr>
<tr class="altColor" id="i4">
<td class="colFirst"><code>static java.lang.String</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#gensalt(int,java.security.SecureRandom)">gensalt</a></span>&#8203;(int&nbsp;log_rounds,
java.security.SecureRandom&nbsp;random)</code></th>
<td class="colLast">
<div class="block">Generate a salt for use with the BCrypt.hashpw() method</div>
</td>
</tr>
<tr class="rowColor" id="i5">
<td class="colFirst"><code>static java.lang.String</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#hashpw(java.lang.String,java.lang.String)">hashpw</a></span>&#8203;(java.lang.String&nbsp;password,
java.lang.String&nbsp;salt)</code></th>
<td class="colLast">
<div class="block">Hash a password using the OpenBSD bcrypt scheme</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<div class="inheritedList">
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<a id="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a><code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></div>
</section>
</li>
</ul>
</section>
<section class="details">
<ul class="blockList">
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<li class="blockList">
<section class="constructorDetails"><a id="constructor.detail">
<!--   -->
</a>
<h2>Constructor Details</h2>
<ul class="blockList">
<li class="blockList">
<section class="detail">
<h3><a id="&lt;init&gt;()">BCrypt</a></h3>
<div class="memberSignature"><span class="modifiers">public</span>&nbsp;<span class="memberName">BCrypt</span>()</div>
</section>
</li>
</ul>
</section>
</li>
<!-- ============ METHOD DETAIL ========== -->
<li class="blockList">
<section class="methodDetails"><a id="method.detail">
<!--   -->
</a>
<h2>Method Details</h2>
<ul class="blockList">
<li class="blockList">
<section class="detail">
<h3><a id="crypt_raw(byte[],byte[],int,int[])">crypt_raw</a></h3>
<div class="memberSignature"><span class="modifiers">public</span>&nbsp;<span class="returnType">byte[]</span>&nbsp;<span class="memberName">crypt_raw</span>&#8203;(<span class="arguments">byte[]&nbsp;password,
byte[]&nbsp;salt,
int&nbsp;log_rounds,
int[]&nbsp;cdata)</span></div>
<div class="block">Perform the central password hashing step in the
 bcrypt scheme</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>password</code> - the password to hash</dd>
<dd><code>salt</code> - the binary salt to hash with the password</dd>
<dd><code>log_rounds</code> - the binary logarithm of the number
 of rounds of hashing to apply</dd>
<dd><code>cdata</code> - the plaintext to encrypt</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>an array containing the binary hashed password</dd>
</dl>
</section>
</li>
<li class="blockList">
<section class="detail">
<h3><a id="hashpw(java.lang.String,java.lang.String)">hashpw</a></h3>
<div class="memberSignature"><span class="modifiers">public static</span>&nbsp;<span class="returnType">java.lang.String</span>&nbsp;<span class="memberName">hashpw</span>&#8203;(<span class="arguments">java.lang.String&nbsp;password,
java.lang.String&nbsp;salt)</span></div>
<div class="block">Hash a password using the OpenBSD bcrypt scheme</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>password</code> - the password to hash</dd>
<dd><code>salt</code> - the salt to hash with (perhaps generated
 using BCrypt.gensalt)</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the hashed password</dd>
</dl>
</section>
</li>
<li class="blockList">
<section class="detail">
<h3><a id="gensalt(int,java.security.SecureRandom)">gensalt</a></h3>
<div class="memberSignature"><span class="modifiers">public static</span>&nbsp;<span class="returnType">java.lang.String</span>&nbsp;<span class="memberName">gensalt</span>&#8203;(<span class="arguments">int&nbsp;log_rounds,
java.security.SecureRandom&nbsp;random)</span></div>
<div class="block">Generate a salt for use with the BCrypt.hashpw() method</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>log_rounds</code> - the log2 of the number of rounds of
 hashing to apply - the work factor therefore increases as
 2**log_rounds.</dd>
<dd><code>random</code> - an instance of SecureRandom to use</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>an encoded salt value</dd>
</dl>
</section>
</li>
<li class="blockList">
<section class="detail">
<h3><a id="gensalt(int)">gensalt</a></h3>
<div class="memberSignature"><span class="modifiers">public static</span>&nbsp;<span class="returnType">java.lang.String</span>&nbsp;<span class="memberName">gensalt</span>&#8203;(<span class="arguments">int&nbsp;log_rounds)</span></div>
<div class="block">Generate a salt for use with the BCrypt.hashpw() method</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>log_rounds</code> - the log2 of the number of rounds of
 hashing to apply - the work factor therefore increases as
 2**log_rounds.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>an encoded salt value</dd>
</dl>
</section>
</li>
<li class="blockList">
<section class="detail">
<h3><a id="gensalt()">gensalt</a></h3>
<div class="memberSignature"><span class="modifiers">public static</span>&nbsp;<span class="returnType">java.lang.String</span>&nbsp;<span class="memberName">gensalt</span>()</div>
<div class="block">Generate a salt for use with the BCrypt.hashpw() method,
 selecting a reasonable default for the number of hashing
 rounds to apply</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>an encoded salt value</dd>
</dl>
</section>
</li>
<li class="blockList">
<section class="detail">
<h3><a id="checkpw(java.lang.String,java.lang.String)">checkpw</a></h3>
<div class="memberSignature"><span class="modifiers">public static</span>&nbsp;<span class="returnType">boolean</span>&nbsp;<span class="memberName">checkpw</span>&#8203;(<span class="arguments">java.lang.String&nbsp;plaintext,
java.lang.String&nbsp;hashed)</span></div>
<div class="block">Check that a plaintext password matches a previously hashed
 one</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>plaintext</code> - the plaintext password to verify</dd>
<dd><code>hashed</code> - the previously-hashed password</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>true if the passwords match, false otherwise</dd>
</dl>
</section>
</li>
</ul>
</section>
</li>
</ul>
</section>
</div>
<!-- ========= END OF CLASS DATA ========= -->
</main>
<footer role="contentinfo">
<nav role="navigation">
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a id="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a id="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../index.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/BCrypt.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../index-files/index-1.html">Index</a></li>
<li><a href="../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
</div>
<a id="skip.navbar.bottom">
<!--   -->
</a>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</nav>
</footer>
</div>
</div>
</body>
</html>
